<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">Patients</div>
                    <div class="alert alert-danger" role="alert" v-if="error">
                        {{ error }}
                    </div>

                    <div class="card-body">
                        <table class="table">
                            <thead>
                            <tr>
                                <th>Name</th>
                                <th>Email</th>
                                <th>Day of week</th>
                                <th>Date</th>
                                <th>Description</th>
                                <th>Updated</th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr v-for="patient in patients.data">
                                <td>{{ patient.user.name }}</td>
                                <td>{{ patient.user.email }}</td>
                                <td>{{ patient.day_of_week }}</td>
                                <td>{{ patient.slot_date}} {{ patient.slot_time }}</td>
                                <td>{{ patient.description }}</td>
                                <td>{{ formatDate(patient.updated_at) }}</td>
                            </tr>
                            </tbody>
                        </table>
                        <pagination :data="patients" @pagination-change-page="fetchPatients"></pagination>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from "axios";
import configs from './../../config';
import pagination from 'laravel-vue-pagination';

export default {
    components: { pagination },
    data() {
        return {
            patients: null,
            loading: null,
            error: null,
        }
    },

    mounted() {
        this.fetchPatients();
    },

    methods: {
        fetchPatients(page = 1) {
            this.loading = true;
            axios
                .get(configs.DOCTOR_APPOINTMENTS_URL + page)
                .then(response => {
                    this.loading = false;
                    this.patients = response.data;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        formatDate(dateString) {
            let date = new Date(dateString);
            let offset = date.getTimezoneOffset();

            return new Date(date.getTime() - (offset*60*1000)).toISOString()
                .replace(/T/, ' ')
                .replace(/\..+/, '');
        }
    }
}
</script>
